#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <glib.h>

#include "binding_generic.h"

#include "db.h"

/*#define errormsg(fmt,args...) fprintf (stderr, "%s:%d:%s(): " fmt "\n", __FILE__, __LINE__, __PRETTY_FUNCTION__ , ##args)
*/

typedef struct
{
        int placeholder;
}
BondConnection;

BondConnection conn;

void *pap_doquery (void *connection, char *query)
{
        return db_sql (NULL, query);
}

int pap_query_next (void *object)
{
        return db_movenext (object);
}

int pap_query_length (void *object)
{
        return db_numrows (object);
}

int pap_query_reset (void *query)
{
#warning not written
        return 0;
}

int pap_query_compare (void *query, char *querystr)
{
#warning not written
        return 0;
}

int pap_query_ncolumns (void *query)
{
#warning not written
        return 0;
}

char *pap_query_column_name (void *query, int pos)
{
#warning not written
        return NULL;
}

int pap_query_has_more (void *object)
{
        Object *obj = object;
        if (!object)
                return 0;

        if (pap_query_length (object) <= 0)
                return 0;

        return (obj->row < (pap_query_length (object) - 1));
}

char *pap_query_get_value (void *object, char *field)
{
        char *retval;

        if (db_getvalue (object, field, NULL, &retval) == 0)
                return retval;

        return NULL;
}

void *pap_connect_db (char *connectstr, char *provider)
{
        if (db_init (connectstr) < 0) {
                errormsg ("No database found");
                return NULL;
        }

        /*	errormsg ("Connected to database: %s", connectstr); */

        return &conn;
}

int pap_disconnect_db (void *connection)
{
        return 0;
}

int pap_clearquery (void *object)
{
        db_freeobject (object);
        return 0;
}

int pap_cleanup (void)
{
        db_cleanup ();
        return 0;
}

int pap_init ()
{
        return 0;
}

char *pap_type ()
{
        static char *retval = NULL;

        if (!retval)
                retval = strdup ("bond");

        return retval;
}
