#ifndef DATASOURCE_H
#define DATASOURCE_H

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#include "binding.h"

typedef struct
{
        char *name;
        char *type;
        char *connection;
	char *provider;

        void *db_con;
        Binding *binding;
}
Database;

typedef struct
{
        char *name;
        char *query;

        void *db_query;

        Database *db;
}
DataSource;

int datasource_clear ();
int datasource_add_raw (char *name, char *database, char *query);
DataSource *datasource_get (char *name);
int datasource_query(DataSource *datasource);

int database_clear ();
int database_add_raw (char *name, char *type, char *provider, char *connectstr);
int database_add (xmlNode *doc, xmlNode *database);
Database *database_get (char *name);

#endif /* DATASOURCE_H */
