.\"                                      Hey, EMACS: -*- nroff -*-
.\" First parameter, NAME, should be all caps
.\" Second parameter, SECTION, should be 1-8, maybe w/ subsection
.\" other parameters are allowed: see man(7), man(1)
.TH PAPYRUS 1 "May 10, 2002" Papyrus "Papyrus Manual"
.\" Please adjust this date whenever revising the manpage.
.\"
.\" Some roff macros, for reference:
.\" .nh        disable hyphenation
.\" .hy        enable hyphenation
.\" .ad l      left justify
.\" .ad b      justify to both left and right margins
.\" .nf        disable filling
.\" .fi        enable filling
.\" .br        insert line break
.\" .sp <n>    insert n+1 empty lines
.\" for manpage-specific macros, see man(7)
.SH NAME
papyrus \- generate different types of database report (ps/pdf/html/text .\|.\|.\|)
.SH SYNOPSIS
.B papyrus
.RI [ options ] " files" ...
.br
.SH DESCRIPTION
This manual page documents briefly the
.B papyrus
commands.
This manual page was written for the Debian distribution
because the original program does not have a manual page.
Instead, it has documentation in the GNU Info format; see below.
.PP
.\" TeX users may be more comfortable with the \fB<whatever>\fP and
.\" \fI<whatever>\fP escape sequences to invode bold face and italics, 
.\" respectively.
\fBpapyrus\fP is a program that generate from a high\-level and easy to
write and read XML document to a number of well\-known document formats.
.PP
More specifically,
.B papyrus
document format specifies database and SQL statements with command\-line arguments
.SH OPTIONS
These programs follow the usual GNU command line syntax, with long
options starting with two dashes (`-').
A summary of options is included below.
For a complete description, see the Info files.
.TP
.B \-h, \-\-help
Show summary of options.
.TP
.BI \-o,\ \-\-output \ filename
Output to specific file (default to stdout i.e. console). Also file extention determines output format
.TP
.BI \-a,\ \-\-arg \ variable=value
Add variable definition 
.TP
.BI \-t,\ \-\-type \ pdf\ |\ ps\ |\ dvi\ |\ html\ |\ txt
Specify output file type explicitly
.TP
.B \-v, \-\-view
View results on screen after output file generation (default: acroread for pdf, gv for postscript, netscape for html, xdvi for dvi, less for text)
.TP
.B \-p, \-\-print
Print report to default printer
.TP
.B \-V, \-\-verbose
Display verbose output
.SH EXAMPLES
Here are very simple papyrus XML report.

.B papyrus
\-o
.I
foo.pdf foo.xml
.PP
The above command generates an output
.I foo.pdf
from
.I foo.xml
Now, the next command generates different output
.I foo.pdf
from the same
.I foo.xml

.B papyrus
\-o
.I foo.html foo.xml

The two examples are normal way to use
.B papyrus
. However, for some reason, if different file extension name is required or should be omitted, then type can specified explicitly as

.B papyrus
\-o
.I foo
-t
.I pdf foo.xml

Of course, you could get same result by 

.B papyrus
\-o
.I foo.pdf foo.xml
.br
mv foo.pdf foo

But the latter method needs a care, since if file
.I foo.pdf
has already existed,
.B papyrus
will overwrite it during
.I foo.pdf
generation.

.B papyrus
tries hard to generate all geneated documents look same as much as possible, but in some cases it may look quite different!
.PP
If it fails to generate a Postscript or PDF document by your mistake or by a bug of this problem,  you may find some clue by turing on verbose option.

.B papyrus
\-V \-o
.I foo.pdf foo.xml

In mose cases, you will need to provide some values to
.B papyrus to get different results. For example, if your
.B papyrus
document connect to database and retrieve some information, you may need to provide id and password. The following example describes that:

.B papyrus
-a
.I id=starbuck
-a
.I password=1234
-o
.I foo.ps foo.xml

.SH SEE ALSO
Actually,
.BR papyrus (1)
is a front-end script. The real XML conversion is done by
.BR papyrus_backend (1).
Mapping from that the given XML to various other format is done by
.BR papyrus_latexengine (1),
.BR papyrus_htmlengine (1),
and
.BR papyrus_textengine (1).
.PP
The programs are documented fully by
.IR "The Rise of Treshna Enterprise" ,
available at
.UR www.treshna.com/projects/papyrus/
Tresh
.UE
.SH AUTHOR
This manual page was written by Francis Lee <francis@treshna.com>,
for the Debian GNU/Linux system (but may be used by others).
