#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "equation.h"

long int lrintl(long double x);

int run (char *eqn, long int answer)
{
	long double d;
	
	d = equation_evaluate (eqn);
	printf ("%s = %Lf", eqn, d);
	if (lrintl (d) != answer)
		{
		printf (" INCORRECT\n");
		return -1;
		}
	else
		{
		printf (" CORRECT\n");
		return 0;
		}
}


int main (int argc, char *argv[])
{
	if (run ("4", 4) != 0) return 1;
	if (run ("-5", -5) != 0) return 1;
	if (run ("4 * 3", 12) != 0) return 1;
	if (run ("4 * 1", 4) != 0) return 1;
	if (run ("4 + 5", 9) != 0) return 1;
	if (run ("10 * 1.1", 11) != 0) return 1;
	if (run ("4 * 3", 12) != 0) return 1;
	if (run ("4 * 3", 12) != 0) return 1;
	if (run ("5 ^ 2", 25) != 0) return 1;
	if (run ("0 ? 5 : 3", 3) != 0) return 1;
	if (run ("1 ? 5 : 3", 5) != 0) return 1;
	if (run ("1 > 3 ? 5 : 4", 4) != 0) return 1;
	if (run ("1 != 1", 0) != 0) return 1;
	if (run ("1 = 3 ? 1 : 0", 0) != 0) return 1;
	if (run ("49 gt 35 ? (49 lt 50 ? 1 : 0) :0", 1) != 0) return 1;
	if (run ("50 gt 35 ? (50 lt 50 ? 1 : 0) :0", 0) != 0) return 1;
	if (run ("35 gt 35 ? (35 lt 50 ? 1 : 0) :0", 0) != 0) return 1;
	if (run ("36 gt 35 ? (36 lt 50 ? 1 : 0) :0", 1) != 0) return 1;
	if (run ("100 gt 35 ? (100 lt 50 ? 1 : 0) :0", 0) != 0) return 1;
	if (run ("NaN gt 30 ? (NaN lt 50 ? 1 : 0) : 0", 0) != 0) return 1;
	return 0;
}
