#ifndef EQUATION_H
#define EQUATION_H

int yylex ();

int yyerror (char *s);
long double apply_func_1 (char *function, long double arg);
long double apply_func_2 (char *function, long double arg1, long double arg2);
long double apply_func_3 (char *function, long double arg1, long double arg2, long double arg3);

typedef long double (*func_1)(long double arg);
typedef long double (*func_2)(long double arg1, long double arg2);
typedef long double (*func_3)(long double arg1, long double arg2, long double arg3);

int add_func_1 (char *name, func_1 f);
int add_func_2 (char *name, func_2 f);
int add_func_3 (char *name, func_3 f);

long double equation_evaluate (char *equation);

#endif /* EQUATION_H */
