%{
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <bits/nan.h>

#include "parser.h"

long double strtold(const char *nptr, char **endptr);

%}

%option noyywrap
%option yylineno
%%
[0-9]*		{ eqnlval.d = strtold (eqntext, NULL); return NUMBER; }
[0-9]*\.[0-9]+	{ eqnlval.d = strtold (eqntext, NULL); return NUMBER; }
[0-9]+\.[0-9]*	{ eqnlval.d = strtold (eqntext, NULL); return NUMBER; }
"NaN"		{ eqnlval.d = NAN; return NUMBER;}
"lt"		{ return '<';}
"gt"		{ return '>';}
[a-zA-Z_]+	{ eqnlval.string = strdup (eqntext); return STRING; }
[ \t\n]			{ ; }
"!="			{return NEQ;}
.					{return eqntext[0];}
%%
