--
-- TOC Entry ID 4 (OID 17200)
--
-- Name: employee_id_seq Type: SEQUENCE Owner: andru
--

CREATE SEQUENCE "employee_id_seq" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;

--
-- TOC Entry ID 15 (OID 17202)
--
-- Name: employee Type: TABLE Owner: andru
--

CREATE TABLE "employee" (
	"id" integer DEFAULT nextval('"employee_id_seq"'::text) NOT NULL,
	"username" text NOT NULL,
	"password" text NOT NULL,
	"fullnm" text NOT NULL,
	"email" text,
	Constraint "employee_pkey" Primary Key ("username")
);

--
-- TOC Entry ID 6 (OID 17208)
--
-- Name: company_id_seq Type: SEQUENCE Owner: andru
--

CREATE SEQUENCE "company_id_seq" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;

--
-- TOC Entry ID 16 (OID 17210)
--
-- Name: company Type: TABLE Owner: andru
--

CREATE TABLE "company" (
	"id" integer DEFAULT nextval('"company_id_seq"'::text) NOT NULL,
	"name" text NOT NULL,
	"contact" text NOT NULL,
	"address" text NOT NULL,
	"phone" text,
	"cell" text,
	"hourlyrate" double precision NOT NULL,
	"mincharge" double precision,
	Constraint "company_pkey" Primary Key ("name")
);

--
-- TOC Entry ID 8 (OID 17216)
--
-- Name: worktype_id_seq Type: SEQUENCE Owner: andru
--

CREATE SEQUENCE "worktype_id_seq" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;

--
-- TOC Entry ID 17 (OID 17218)
--
-- Name: worktype Type: TABLE Owner: andru
--

CREATE TABLE "worktype" (
	"id" integer DEFAULT nextval('"worktype_id_seq"'::text) NOT NULL,
	"description" text NOT NULL,
	Constraint "worktype_pkey" Primary Key ("description")
);

--
-- TOC Entry ID 18 (OID 17224)
--
-- Name: invoice Type: TABLE Owner: andru
--

CREATE TABLE "invoice" (
	"invoicenumber" integer NOT NULL,
	"gendate" date DEFAULT date('today'::text) NOT NULL,
	"company" integer NOT NULL,
	Constraint "invoice_pkey" Primary Key ("invoicenumber")
);

--
-- TOC Entry ID 10 (OID 17227)
--
-- Name: timesheet_id_seq Type: SEQUENCE Owner: andru
--

CREATE SEQUENCE "timesheet_id_seq" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;

--
-- TOC Entry ID 19 (OID 17229)
--
-- Name: timesheet Type: TABLE Owner: andru
--

CREATE TABLE "timesheet" (
	"id" integer DEFAULT nextval('"timesheet_id_seq"'::text) NOT NULL,
	"gendate" date DEFAULT date('today'::text) NOT NULL,
	"hours" double precision NOT NULL,
	"description" text,
	"worktype" integer NOT NULL,
	"employee" integer NOT NULL,
	"company" integer NOT NULL,
	"invoice" integer,
	"oninvoice" boolean,
	Constraint "timesheet_pkey" Primary Key ("id")
);

--
-- TOC Entry ID 12 (OID 17235)
--
-- Name: sale_id_seq Type: SEQUENCE Owner: andru
--

CREATE SEQUENCE "sale_id_seq" start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;

--
-- TOC Entry ID 20 (OID 17237)
--
-- Name: sale Type: TABLE Owner: andru
--

CREATE TABLE "sale" (
	"id" integer DEFAULT nextval('"sale_id_seq"'::text) NOT NULL,
	"gendate" date DEFAULT date('today'::text) NOT NULL,
	"description" text NOT NULL,
	"amount" text NOT NULL,
	"company" integer NOT NULL,
	"invoice" integer,
	Constraint "sale_pkey" Primary Key ("id")
);

--
-- TOC Entry ID 21 (OID 17245)
--
-- Name: invoicelist Type: VIEW Owner: andru
--

CREATE VIEW "invoicelist" as SELECT i.invoicenumber, i.gendate, c.name FROM invoice i, company c WHERE (i.company = c.id);

--
-- Data for TOC Entry ID 29 (OID 17202)
--
-- Name: employee Type: TABLE DATA Owner: andru
--


COPY "employee" FROM stdin;
4	andru	xxx	Andru	andru@treshna.com
3	liam	xxx	Liam Boyle	liam@treshna.com
\.
--
-- Data for TOC Entry ID 30 (OID 17210)
--
-- Name: company Type: TABLE DATA Owner: andru
--


COPY "company" FROM stdin;
7	treshna Enterprises	da Emperor	54 Oxford Tce	\N	\N	0	0
\.
--
-- Data for TOC Entry ID 31 (OID 17218)
--
-- Name: worktype Type: TABLE DATA Owner: andru
--


COPY "worktype" FROM stdin;
3	Software Development
\.
--
-- Data for TOC Entry ID 32 (OID 17224)
--
-- Name: invoice Type: TABLE DATA Owner: andru
--


COPY "invoice" FROM stdin;
1367	2002-08-17	7
\.
--
-- Data for TOC Entry ID 33 (OID 17229)
--
-- Name: timesheet Type: TABLE DATA Owner: andru
--


COPY "timesheet" FROM stdin;
61	2002-04-30	0.5	Normal work	3	3	7	1367	t
\.
--
-- Data for TOC Entry ID 34 (OID 17237)
--
-- Name: sale Type: TABLE DATA Owner: andru
--


COPY "sale" FROM stdin;
92	2002-08-18	17inch ViewSonic mointor for Health and Fitness	365	9	1367
\.

--
-- TOC Entry ID 23 (OID 17619)
--
-- Name: "employee_id_key" Type: INDEX Owner: andru
--

CREATE UNIQUE INDEX employee_id_key ON employee USING btree (id);

--
-- TOC Entry ID 24 (OID 17620)
--
-- Name: "company_id_key" Type: INDEX Owner: andru
--

CREATE UNIQUE INDEX company_id_key ON company USING btree (id);

--
-- TOC Entry ID 25 (OID 17621)
--
-- Name: "worktype_id_key" Type: INDEX Owner: andru
--

CREATE UNIQUE INDEX worktype_id_key ON worktype USING btree (id);

--
-- TOC Entry ID 45 (OID 17623)
--
-- Name: "RI_ConstraintTrigger_17622" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER INSERT OR UPDATE ON "invoice"  FROM "company" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('ref_company', 'invoice', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 37 (OID 17625)
--
-- Name: "RI_ConstraintTrigger_17624" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER DELETE ON "company"  FROM "invoice" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_del" ('ref_company', 'invoice', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 38 (OID 17627)
--
-- Name: "RI_ConstraintTrigger_17626" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER UPDATE ON "company"  FROM "invoice" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('ref_company', 'invoice', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 50 (OID 17629)
--
-- Name: "RI_ConstraintTrigger_17628" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_worktype" AFTER INSERT OR UPDATE ON "timesheet"  FROM "worktype" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('ref_worktype', 'timesheet', 'worktype', 'UNSPECIFIED', 'worktype', 'id');

--
-- TOC Entry ID 43 (OID 17631)
--
-- Name: "RI_ConstraintTrigger_17630" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_worktype" AFTER DELETE ON "worktype"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_del" ('ref_worktype', 'timesheet', 'worktype', 'UNSPECIFIED', 'worktype', 'id');

--
-- TOC Entry ID 44 (OID 17633)
--
-- Name: "RI_ConstraintTrigger_17632" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_worktype" AFTER UPDATE ON "worktype"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('ref_worktype', 'timesheet', 'worktype', 'UNSPECIFIED', 'worktype', 'id');

--
-- TOC Entry ID 51 (OID 17635)
--
-- Name: "RI_ConstraintTrigger_17634" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_employee" AFTER INSERT OR UPDATE ON "timesheet"  FROM "employee" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('ref_employee', 'timesheet', 'employee', 'UNSPECIFIED', 'employee', 'id');

--
-- TOC Entry ID 35 (OID 17637)
--
-- Name: "RI_ConstraintTrigger_17636" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_employee" AFTER DELETE ON "employee"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_del" ('ref_employee', 'timesheet', 'employee', 'UNSPECIFIED', 'employee', 'id');

--
-- TOC Entry ID 36 (OID 17639)
--
-- Name: "RI_ConstraintTrigger_17638" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_employee" AFTER UPDATE ON "employee"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('ref_employee', 'timesheet', 'employee', 'UNSPECIFIED', 'employee', 'id');

--
-- TOC Entry ID 52 (OID 17641)
--
-- Name: "RI_ConstraintTrigger_17640" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER INSERT OR UPDATE ON "timesheet"  FROM "company" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('ref_company', 'timesheet', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 39 (OID 17643)
--
-- Name: "RI_ConstraintTrigger_17642" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER DELETE ON "company"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_del" ('ref_company', 'timesheet', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 40 (OID 17645)
--
-- Name: "RI_ConstraintTrigger_17644" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER UPDATE ON "company"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('ref_company', 'timesheet', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 53 (OID 17647)
--
-- Name: "RI_ConstraintTrigger_17646" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_invoice" AFTER INSERT OR UPDATE ON "timesheet"  FROM "invoice" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('ref_invoice', 'timesheet', 'invoice', 'UNSPECIFIED', 'invoice', 'invoicenumber');

--
-- TOC Entry ID 46 (OID 17649)
--
-- Name: "RI_ConstraintTrigger_17648" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_invoice" AFTER DELETE ON "invoice"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_del" ('ref_invoice', 'timesheet', 'invoice', 'UNSPECIFIED', 'invoice', 'invoicenumber');

--
-- TOC Entry ID 47 (OID 17651)
--
-- Name: "RI_ConstraintTrigger_17650" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_invoice" AFTER UPDATE ON "invoice"  FROM "timesheet" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('ref_invoice', 'timesheet', 'invoice', 'UNSPECIFIED', 'invoice', 'invoicenumber');

--
-- TOC Entry ID 54 (OID 17653)
--
-- Name: "RI_ConstraintTrigger_17652" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER INSERT OR UPDATE ON "sale"  FROM "company" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('ref_company', 'sale', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 41 (OID 17655)
--
-- Name: "RI_ConstraintTrigger_17654" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER DELETE ON "company"  FROM "sale" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_del" ('ref_company', 'sale', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 42 (OID 17657)
--
-- Name: "RI_ConstraintTrigger_17656" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_company" AFTER UPDATE ON "company"  FROM "sale" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('ref_company', 'sale', 'company', 'UNSPECIFIED', 'company', 'id');

--
-- TOC Entry ID 55 (OID 17659)
--
-- Name: "RI_ConstraintTrigger_17658" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_invoice" AFTER INSERT OR UPDATE ON "sale"  FROM "invoice" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_check_ins" ('ref_invoice', 'sale', 'invoice', 'UNSPECIFIED', 'invoice', 'invoicenumber');

--
-- TOC Entry ID 48 (OID 17661)
--
-- Name: "RI_ConstraintTrigger_17660" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_invoice" AFTER DELETE ON "invoice"  FROM "sale" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_del" ('ref_invoice', 'sale', 'invoice', 'UNSPECIFIED', 'invoice', 'invoicenumber');

--
-- TOC Entry ID 49 (OID 17663)
--
-- Name: "RI_ConstraintTrigger_17662" Type: TRIGGER Owner: andru
--

CREATE CONSTRAINT TRIGGER "ref_invoice" AFTER UPDATE ON "invoice"  FROM "sale" NOT DEFERRABLE INITIALLY IMMEDIATE FOR EACH ROW EXECUTE PROCEDURE "RI_FKey_noaction_upd" ('ref_invoice', 'sale', 'invoice', 'UNSPECIFIED', 'invoice', 'invoicenumber');

--
-- TOC Entry ID 5 (OID 17200)
--
-- Name: employee_id_seq Type: SEQUENCE SET Owner: andru
--

SELECT setval ('"employee_id_seq"', 7, true);

--
-- TOC Entry ID 7 (OID 17208)
--
-- Name: company_id_seq Type: SEQUENCE SET Owner: andru
--

SELECT setval ('"company_id_seq"', 47, true);

--
-- TOC Entry ID 9 (OID 17216)
--
-- Name: worktype_id_seq Type: SEQUENCE SET Owner: andru
--

SELECT setval ('"worktype_id_seq"', 3, true);

--
-- TOC Entry ID 11 (OID 17227)
--
-- Name: timesheet_id_seq Type: SEQUENCE SET Owner: andru
--

SELECT setval ('"timesheet_id_seq"', 282, true);

--
-- TOC Entry ID 13 (OID 17235)
--
-- Name: sale_id_seq Type: SEQUENCE SET Owner: andru
--

SELECT setval ('"sale_id_seq"', 94, true);

