
/*
 * this is a copy of the file interface-glade.c which is created by glade
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include <bc.h>

#include "callbacks.h"
#include "report.h"
#include "interface.h"
#include "support.h"
#include "support_usr.h"
#include "binding.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

extern GList *dbconn_strings;
extern GList *dbconn_types;
extern GList *parameter_list;
extern GtkWidget *window1;
extern GList *databases;

GtkWidget *
create_window1(void)
	{
	GtkWidget *window1;
	GdkPixbuf *window1_icon_pixbuf;
	GtkWidget *vbox_main;
	GtkWidget *menubar1;
	GtkWidget *menuitem_file;
	GtkWidget *menuitem_file_menu;
	GtkWidget *open1;
	GtkWidget *image12;
	GtkWidget *parameters;
	GtkWidget *image13;
	GtkWidget *save_as_favourite1;
	GtkWidget *image14;
	GtkWidget *execute;
	GtkWidget *image15;
	GtkWidget *separatormenuitem1;
	GtkWidget *quit1;
	GtkWidget *menuitem_help;
	GtkWidget *menuitem_help_menu;
	GtkWidget *about1;
	GtkWidget *hbox4;
	GtkWidget *vbox1;
	GtkWidget *hbox1;
	GtkWidget *label_report;
	GtkWidget *entry_report_filename;
	GtkWidget *button_browse;
	GtkWidget *label2;
	GtkWidget *scrolledwindow1;
	GtkWidget *treeview_favourites;
	GtkWidget *vbox14;
	GtkWidget *hbuttonbox2;
	GtkWidget *button_param;
	GtkWidget *alignment8;
	GtkWidget *hbox19;
	GtkWidget *image5;
	GtkWidget *label25;
	GtkWidget *button_savefav;
	GtkWidget *alignment9;
	GtkWidget *hbox21;
	GtkWidget *image6;
	GtkWidget *label28;
	GtkWidget *hbox20;
	GtkWidget *label26;
	GtkWidget *entry_outputfile;
	GtkWidget *button_browseoutput;
	GtkWidget *hbox16;
	GtkWidget *label22;
	GtkWidget *combobox_outputtypes;
	GtkWidget *drawingarea1;
	GtkWidget *hbox22;
	GtkWidget *vbox2;
	GtkWidget *checkbutton_openviewer;
	GtkWidget *checkbutton_validate;
	GtkWidget *button_exec;
	GtkAccelGroup *accel_group;
	GtkTooltips *tooltips;
	gchar *temp;
	GtkWidget *menuitem_fav;
	GtkWidget *menu_fav;
	GtkWidget *fav_edit;
	GtkWidget *image17;
	GtkWidget *fav_delete;

	tooltips = gtk_tooltips_new();

	accel_group = gtk_accel_group_new();

	window1 = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window1), _("Papyrus"));
	gtk_window_set_position(GTK_WINDOW(window1), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size(GTK_WINDOW(window1), 740, 350);

	window1_icon_pixbuf = create_pixbuf(PAPYRUS_ICON);
	if (window1_icon_pixbuf)
		{
		gtk_window_set_icon(GTK_WINDOW(window1), window1_icon_pixbuf);
		gdk_pixbuf_unref(window1_icon_pixbuf);
		}
	gtk_window_set_role(GTK_WINDOW(window1), "papyrus_main");

	vbox_main = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox_main);
	gtk_container_add(GTK_CONTAINER(window1), vbox_main);

	menubar1 = gtk_menu_bar_new();
	gtk_widget_show(menubar1);
	gtk_box_pack_start(GTK_BOX(vbox_main), menubar1, FALSE, FALSE, 0);

	menuitem_file = gtk_menu_item_new_with_mnemonic(_("_File"));
	gtk_widget_show(menuitem_file);
	gtk_container_add(GTK_CONTAINER(menubar1), menuitem_file);

	menuitem_file_menu = gtk_menu_new();
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menuitem_file), menuitem_file_menu);

	open1 = gtk_image_menu_item_new_with_mnemonic(_("_Open..."));
	gtk_widget_show(open1);
	gtk_container_add(GTK_CONTAINER(menuitem_file_menu), open1);

	image12 = gtk_image_new_from_stock("gtk-open", GTK_ICON_SIZE_MENU);
	gtk_widget_show(image12);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(open1), image12);

	parameters = gtk_image_menu_item_new_with_mnemonic(_("_Parameters..."));
	gtk_widget_show(parameters);
	gtk_widget_set_sensitive(parameters, FALSE);
	gtk_container_add(GTK_CONTAINER(menuitem_file_menu), parameters);

	image13 = gtk_image_new_from_stock("gtk-properties", GTK_ICON_SIZE_MENU);
	gtk_widget_show(image13);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(parameters), image13);

	save_as_favourite1 =
	    gtk_image_menu_item_new_with_mnemonic(_("_Save as favourite..."));
	gtk_widget_show(save_as_favourite1);
	gtk_container_add(GTK_CONTAINER(menuitem_file_menu), save_as_favourite1);

	image14 = gtk_image_new_from_stock("gtk-save-as", GTK_ICON_SIZE_MENU);
	gtk_widget_show(image14);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(save_as_favourite1),
	                              image14);

	execute = gtk_image_menu_item_new_with_mnemonic(_("E_xecute"));
	gtk_widget_show(execute);
	gtk_container_add(GTK_CONTAINER(menuitem_file_menu), execute);
	gtk_widget_add_accelerator(execute, "activate", accel_group,
	                           GDK_X, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	image15 = gtk_image_new_from_stock("gtk-execute", GTK_ICON_SIZE_MENU);
	gtk_widget_show(image15);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(execute), image15);

	separatormenuitem1 = gtk_separator_menu_item_new();
	gtk_widget_show(separatormenuitem1);
	gtk_container_add(GTK_CONTAINER(menuitem_file_menu), separatormenuitem1);
	gtk_widget_set_sensitive(separatormenuitem1, FALSE);

	quit1 = gtk_image_menu_item_new_from_stock("gtk-quit", accel_group);
	gtk_widget_show(quit1);
	gtk_container_add(GTK_CONTAINER(menuitem_file_menu), quit1);

	menuitem_fav = gtk_menu_item_new_with_mnemonic(_("F_avourites"));
	gtk_widget_show(menuitem_fav);
	gtk_container_add(GTK_CONTAINER(menubar1), menuitem_fav);

	menu_fav = gtk_menu_new();
	gtk_widget_set_name(menu_fav, "menu_fav");
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menuitem_fav), menu_fav);

	fav_edit = gtk_image_menu_item_new_with_mnemonic(_("_Edit..."));
	gtk_widget_set_name(fav_edit, "fav_edit");
	gtk_widget_show(fav_edit);
	gtk_container_add(GTK_CONTAINER(menu_fav), fav_edit);
	gtk_widget_add_accelerator(fav_edit, "activate", accel_group,
	                           GDK_E, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	image17 = gtk_image_new_from_stock("gtk-properties", GTK_ICON_SIZE_MENU);
	gtk_widget_set_name(image17, "image17");
	gtk_widget_show(image17);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(fav_edit), image17);

	fav_delete = gtk_image_menu_item_new_from_stock("gtk-delete", accel_group);
	gtk_widget_set_name(fav_delete, "fav_delete");
	gtk_widget_show(fav_delete);
	gtk_container_add(GTK_CONTAINER(menu_fav), fav_delete);
	gtk_widget_add_accelerator(fav_delete, "activate", accel_group,
	                           GDK_K, GDK_CONTROL_MASK, GTK_ACCEL_VISIBLE);

	g_signal_connect((gpointer) fav_edit, "activate",
	                 G_CALLBACK(on_fav_edit_activate), NULL);
	g_signal_connect((gpointer) fav_delete, "activate",
	                 G_CALLBACK(on_fav_delete_activate), NULL);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF(menu_fav, menu_fav, "menu_fav");
	GLADE_HOOKUP_OBJECT(menu_fav, fav_edit, "fav_edit");
	GLADE_HOOKUP_OBJECT(menu_fav, image17, "image17");
	GLADE_HOOKUP_OBJECT(menu_fav, fav_delete, "fav_delete");

	gtk_menu_set_accel_group(GTK_MENU(menu_fav), accel_group);

	menuitem_help = gtk_menu_item_new_with_mnemonic(_("_Help"));
	gtk_widget_show(menuitem_help);
	gtk_container_add(GTK_CONTAINER(menubar1), menuitem_help);

	menuitem_help_menu = gtk_menu_new();
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(menuitem_help), menuitem_help_menu);

	about1 = gtk_menu_item_new_with_mnemonic(_("_About"));
	gtk_widget_show(about1);
	gtk_container_add(GTK_CONTAINER(menuitem_help_menu), about1);

	hbox4 = gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox4);
	gtk_box_pack_start(GTK_BOX(vbox_main), hbox4, TRUE, TRUE, 0);

	vbox1 = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox1);
	gtk_box_pack_start(GTK_BOX(hbox4), vbox1, TRUE, TRUE, 0);

	hbox1 = gtk_hbox_new(FALSE, 10);
	gtk_widget_show(hbox1);
	gtk_box_pack_start(GTK_BOX(vbox1), hbox1, FALSE, FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox1), 16);

	label_report = gtk_label_new(_("Report:"));
	gtk_widget_show(label_report);
	gtk_box_pack_start(GTK_BOX(hbox1), label_report, FALSE, FALSE, 0);

	entry_report_filename = gtk_entry_new();
	gtk_widget_show(entry_report_filename);
	gtk_box_pack_start(GTK_BOX(hbox1), entry_report_filename, TRUE, TRUE, 0);

	button_browse = gtk_button_new_with_mnemonic(_("_Browse..."));
	gtk_widget_show(button_browse);
	gtk_box_pack_start(GTK_BOX(hbox1), button_browse, FALSE, FALSE, 0);

	label2 = gtk_label_new(_("Favourites:"));
	gtk_widget_show(label2);
	gtk_box_pack_start(GTK_BOX(vbox1), label2, FALSE, FALSE, 0);
	gtk_misc_set_alignment(GTK_MISC(label2), 0, 0.5);
	gtk_misc_set_padding(GTK_MISC(label2), 16, 0);

	scrolledwindow1 = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_show(scrolledwindow1);
	gtk_box_pack_start(GTK_BOX(vbox1), scrolledwindow1, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(scrolledwindow1), 16);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow1),
	                               GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scrolledwindow1),
	                                    GTK_SHADOW_IN);

	treeview_favourites = gtk_tree_view_new();
	gtk_widget_show(treeview_favourites);
	gtk_container_add(GTK_CONTAINER(scrolledwindow1), treeview_favourites);
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(treeview_favourites), FALSE);
	gtk_tree_view_set_rules_hint(GTK_TREE_VIEW(treeview_favourites), TRUE);

	vbox14 = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox14);
	gtk_box_pack_start(GTK_BOX(hbox4), vbox14, FALSE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(vbox14), 2);

	hbuttonbox2 = gtk_hbutton_box_new();
	gtk_widget_show(hbuttonbox2);
	gtk_box_pack_start(GTK_BOX(vbox14), hbuttonbox2, FALSE, FALSE, 0);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(hbuttonbox2), GTK_BUTTONBOX_START);

	button_param = gtk_button_new();
	gtk_widget_show(button_param);
	gtk_container_add(GTK_CONTAINER(hbuttonbox2), button_param);
	gtk_container_set_border_width(GTK_CONTAINER(button_param), 8);
	GTK_WIDGET_SET_FLAGS(button_param, GTK_CAN_DEFAULT);

	alignment8 = gtk_alignment_new(0.5, 0.5, 0, 0);
	gtk_widget_show(alignment8);
	gtk_container_add(GTK_CONTAINER(button_param), alignment8);

	hbox19 = gtk_hbox_new(FALSE, 2);
	gtk_widget_show(hbox19);
	gtk_container_add(GTK_CONTAINER(alignment8), hbox19);

	image5 = gtk_image_new_from_stock("gtk-properties", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show(image5);
	gtk_box_pack_start(GTK_BOX(hbox19), image5, FALSE, FALSE, 0);

	label25 = gtk_label_new_with_mnemonic(_("_Parameters..."));
	gtk_widget_show(label25);
	gtk_box_pack_start(GTK_BOX(hbox19), label25, FALSE, FALSE, 0);

	button_savefav = gtk_button_new();
	gtk_widget_show(button_savefav);
	gtk_container_add(GTK_CONTAINER(hbuttonbox2), button_savefav);
	gtk_container_set_border_width(GTK_CONTAINER(button_savefav), 8);
	GTK_WIDGET_SET_FLAGS(button_savefav, GTK_CAN_DEFAULT);
	gtk_tooltips_set_tip(tooltips, button_savefav,
	                     _("Save this report as a favourite"), NULL);

	alignment9 = gtk_alignment_new(0.5, 0.5, 0, 0);
	gtk_widget_show(alignment9);
	gtk_container_add(GTK_CONTAINER(button_savefav), alignment9);

	hbox21 = gtk_hbox_new(FALSE, 2);
	gtk_widget_show(hbox21);
	gtk_container_add(GTK_CONTAINER(alignment9), hbox21);

	image6 = gtk_image_new_from_stock("gtk-save-as", GTK_ICON_SIZE_BUTTON);
	gtk_widget_show(image6);
	gtk_box_pack_start(GTK_BOX(hbox21), image6, FALSE, FALSE, 0);

	label28 = gtk_label_new_with_mnemonic(_("_Save as favourite..."));
	gtk_widget_show(label28);
	gtk_box_pack_start(GTK_BOX(hbox21), label28, FALSE, FALSE, 0);

	hbox20 = gtk_hbox_new(FALSE, 10);
	gtk_widget_show(hbox20);
	gtk_box_pack_start(GTK_BOX(vbox14), hbox20, FALSE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox20), 8);

	label26 = gtk_label_new(_("Output to:"));
	gtk_widget_show(label26);
	gtk_box_pack_start(GTK_BOX(hbox20), label26, FALSE, FALSE, 0);

	entry_outputfile = gtk_entry_new();
	gtk_widget_show(entry_outputfile);
	gtk_box_pack_start(GTK_BOX(hbox20), entry_outputfile, FALSE, TRUE, 0);
	gtk_entry_set_text(GTK_ENTRY(entry_outputfile), _("/tmp/output.pdf"));

	button_browseoutput = gtk_button_new_with_mnemonic(_("B_rowse..."));
	gtk_widget_show(button_browseoutput);
	gtk_box_pack_start(GTK_BOX(hbox20), button_browseoutput, FALSE, FALSE, 0);

	hbox16 = gtk_hbox_new(FALSE, 10);
	gtk_widget_show(hbox16);
	gtk_box_pack_start(GTK_BOX(vbox14), hbox16, FALSE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox16), 8);

	label22 = gtk_label_new(_("Output as:"));
	gtk_widget_show(label22);
	gtk_box_pack_start(GTK_BOX(hbox16), label22, FALSE, FALSE, 0);

	combobox_outputtypes = gtk_combo_box_new_text();
	gtk_widget_show(combobox_outputtypes);
	gtk_box_pack_start(GTK_BOX(hbox16), combobox_outputtypes, FALSE, FALSE, 0);

	drawingarea1 = gtk_drawing_area_new();
	gtk_widget_show(drawingarea1);
	gtk_box_pack_start(GTK_BOX(vbox14), drawingarea1, TRUE, FALSE, 0);

	hbox22 = gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox22);
	gtk_box_pack_start(GTK_BOX(vbox14), hbox22, FALSE, TRUE, 0);

	vbox2 = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox2);
	gtk_box_pack_start(GTK_BOX(hbox22), vbox2, FALSE, TRUE, 0);

	checkbutton_openviewer =
	    gtk_check_button_new_with_mnemonic(_("Open in viewer"));
	gtk_widget_show(checkbutton_openviewer);
	gtk_box_pack_start(GTK_BOX(vbox2), checkbutton_openviewer, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(checkbutton_openviewer), 8);

	checkbutton_validate =
	    gtk_check_button_new_with_mnemonic(_("Validate against DTD"));
	gtk_widget_show(checkbutton_validate);
	gtk_box_pack_start(GTK_BOX(vbox2), checkbutton_validate, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(checkbutton_validate), 8);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbutton_validate), TRUE);

	button_exec = gtk_button_new_from_stock("gtk-execute");
	gtk_widget_show(button_exec);
	gtk_box_pack_start(GTK_BOX(hbox22), button_exec, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(button_exec), 8);
	GTK_WIDGET_SET_FLAGS(button_exec, GTK_CAN_DEFAULT);

	g_signal_connect((gpointer) window1, "delete_event",
	                 G_CALLBACK(on_window1_delete_event), NULL);
	g_signal_connect((gpointer) open1, "activate",
	                 G_CALLBACK(on_open1_activate), NULL);
	g_signal_connect((gpointer) parameters, "activate",
	                 G_CALLBACK(on_button_param_clicked), NULL);
	g_signal_connect((gpointer) save_as_favourite1, "activate",
	                 G_CALLBACK(on_savefav_activate), NULL);
	g_signal_connect((gpointer) execute, "activate",
	                 G_CALLBACK(on_button_exec_clicked), NULL);
	g_signal_connect((gpointer) quit1, "activate",
	                 G_CALLBACK(on_quit1_activate), NULL);
	g_signal_connect((gpointer) about1, "activate",
	                 G_CALLBACK(on_about1_activate), NULL);
	g_signal_connect((gpointer) entry_report_filename, "changed",
	                 G_CALLBACK(on_entry_report_filename_changed), NULL);
	g_signal_connect((gpointer) button_browse, "clicked",
	                 G_CALLBACK(on_button_browse_clicked), NULL);
	g_signal_connect((gpointer) button_param, "clicked",
	                 G_CALLBACK(on_button_param_clicked), NULL);
	g_signal_connect((gpointer) button_savefav, "clicked",
	                 G_CALLBACK(on_savefav_activate), NULL);
	g_signal_connect((gpointer) entry_outputfile, "changed",
	                 G_CALLBACK(on_entry_outputfile_changed), NULL);
	g_signal_connect((gpointer) button_browseoutput, "clicked",
	                 G_CALLBACK(on_button_browseoutput_clicked), NULL);
	g_signal_connect((gpointer) combobox_outputtypes, "changed",
	                 G_CALLBACK(on_combobox_outputtypes_changed), NULL);
	g_signal_connect((gpointer) button_exec, "clicked",
	                 G_CALLBACK(on_button_exec_clicked), NULL);

	g_signal_connect((gpointer) treeview_favourites, "cursor_changed",
	                 G_CALLBACK(on_treeview_favourites_row_activated), NULL);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF(window1, window1, "window1");
	GLADE_HOOKUP_OBJECT(window1, vbox_main, "vbox_main");
	GLADE_HOOKUP_OBJECT(window1, menubar1, "menubar1");
	GLADE_HOOKUP_OBJECT(window1, menuitem_file, "menuitem_file");
	GLADE_HOOKUP_OBJECT(window1, menuitem_file_menu, "menuitem_file_menu");
	GLADE_HOOKUP_OBJECT(window1, open1, "open1");
	GLADE_HOOKUP_OBJECT(window1, image12, "image12");
	GLADE_HOOKUP_OBJECT(window1, parameters, "parameters");
	GLADE_HOOKUP_OBJECT(window1, image13, "image13");
	GLADE_HOOKUP_OBJECT(window1, save_as_favourite1, "save_as_favourite1");
	GLADE_HOOKUP_OBJECT(window1, image14, "image14");
	GLADE_HOOKUP_OBJECT(window1, execute, "execute");
	GLADE_HOOKUP_OBJECT(window1, image15, "image15");
	GLADE_HOOKUP_OBJECT(window1, separatormenuitem1, "separatormenuitem1");
	GLADE_HOOKUP_OBJECT(window1, quit1, "quit1");
	GLADE_HOOKUP_OBJECT(window1, menuitem_help, "menuitem_help");
	GLADE_HOOKUP_OBJECT(window1, menuitem_help_menu, "menuitem_help_menu");
	GLADE_HOOKUP_OBJECT(window1, about1, "about1");
	GLADE_HOOKUP_OBJECT(window1, hbox4, "hbox4");
	GLADE_HOOKUP_OBJECT(window1, vbox1, "vbox1");
	GLADE_HOOKUP_OBJECT(window1, hbox1, "hbox1");
	GLADE_HOOKUP_OBJECT(window1, label_report, "label_report");
	GLADE_HOOKUP_OBJECT(window1, entry_report_filename, "entry_report_filename");
	GLADE_HOOKUP_OBJECT(window1, button_browse, "button_browse");
	GLADE_HOOKUP_OBJECT(window1, label2, "label2");
	GLADE_HOOKUP_OBJECT(window1, scrolledwindow1, "scrolledwindow1");
	GLADE_HOOKUP_OBJECT(window1, treeview_favourites, "treeview_favourites");
	GLADE_HOOKUP_OBJECT(window1, vbox14, "vbox14");
	GLADE_HOOKUP_OBJECT(window1, hbuttonbox2, "hbuttonbox2");
	GLADE_HOOKUP_OBJECT(window1, button_param, "button_param");
	GLADE_HOOKUP_OBJECT(window1, alignment8, "alignment8");
	GLADE_HOOKUP_OBJECT(window1, hbox19, "hbox19");
	GLADE_HOOKUP_OBJECT(window1, image5, "image5");
	GLADE_HOOKUP_OBJECT(window1, label25, "label25");
	GLADE_HOOKUP_OBJECT(window1, button_savefav, "button_savefav");
	GLADE_HOOKUP_OBJECT(window1, alignment9, "alignment9");
	GLADE_HOOKUP_OBJECT(window1, hbox21, "hbox21");
	GLADE_HOOKUP_OBJECT(window1, image6, "image6");
	GLADE_HOOKUP_OBJECT(window1, label28, "label28");
	GLADE_HOOKUP_OBJECT(window1, hbox20, "hbox20");
	GLADE_HOOKUP_OBJECT(window1, label26, "label26");
	GLADE_HOOKUP_OBJECT(window1, entry_outputfile, "entry_outputfile");
	GLADE_HOOKUP_OBJECT(window1, button_browseoutput, "button_browseoutput");
	GLADE_HOOKUP_OBJECT(window1, hbox16, "hbox16");
	GLADE_HOOKUP_OBJECT(window1, label22, "label22");
	GLADE_HOOKUP_OBJECT(window1, combobox_outputtypes, "combobox_outputtypes");
	GLADE_HOOKUP_OBJECT(window1, drawingarea1, "drawingarea1");
	GLADE_HOOKUP_OBJECT(window1, hbox22, "hbox22");
	GLADE_HOOKUP_OBJECT(window1, checkbutton_openviewer,
	                    "checkbutton_openviewer");
	GLADE_HOOKUP_OBJECT(window1, checkbutton_validate, "checkbutton_validate");
	GLADE_HOOKUP_OBJECT(window1, button_exec, "button_exec");
	GLADE_HOOKUP_OBJECT_NO_REF(window1, tooltips, "tooltips");

	gtk_window_add_accel_group(GTK_WINDOW(window1), accel_group);

	temp =
	    mem_strdup((char *)gtk_entry_get_text(GTK_ENTRY(entry_report_filename)));
	g_strstrip(temp);
	if (strlen(temp))
		gtk_widget_set_sensitive(button_param, TRUE);
	else
		gtk_widget_set_sensitive(button_param, FALSE);
	mem_free(temp);

	return window1;
	}

GtkWidget *
create_dialog_filechooser(const gchar * title)
	{
	GtkWidget *dialog = NULL;
	GdkPixbuf *pixbuf = NULL;

	dialog = gtk_file_chooser_dialog_new(title, NULL,
	                                     GTK_FILE_CHOOSER_ACTION_OPEN,
	                                     GTK_STOCK_CANCEL,
	                                     GTK_RESPONSE_CANCEL,
	                                     GTK_STOCK_OPEN,
	                                     GTK_RESPONSE_ACCEPT, NULL);

	pixbuf = create_pixbuf(PAPYRUS_ICON);
	if (pixbuf)
		{
		gtk_window_set_icon(GTK_WINDOW(dialog), pixbuf);
		gdk_pixbuf_unref(pixbuf);
		}

	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog), TRUE);

	return dialog;
	}

GtkWidget *
create_dialog_about(void)
	{
	GtkWidget *dialog_about;
	GtkWidget *dialog_vbox1;
	GtkWidget *label4;
	GtkWidget *dialog_action_area1;
	GtkWidget *okbutton1;

	GdkPixbuf *pixbuf;

	dialog_about = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dialog_about), _("Papyrus: About"));
	gtk_window_set_resizable(GTK_WINDOW(dialog_about), FALSE);
	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog_about), TRUE);
	gtk_window_set_type_hint(GTK_WINDOW(dialog_about),
	                         GDK_WINDOW_TYPE_HINT_DIALOG);

	pixbuf = create_pixbuf(PAPYRUS_ICON);
	if (pixbuf)
		{
		gtk_window_set_icon(GTK_WINDOW(dialog_about), pixbuf);
		gdk_pixbuf_unref(pixbuf);
		}

	dialog_vbox1 = GTK_DIALOG(dialog_about)->vbox;
	gtk_widget_show(dialog_vbox1);

	label4 =
	    gtk_label_new(_
	                  ("GUI for Papyrus\nby Samuel Halliday\n\ntreshna Enterprises 2004\nhttp://papyrus.treshna.com\n\nPapyrus is released under the\nGPL licence."));
	gtk_widget_show(label4);
	gtk_box_pack_start(GTK_BOX(dialog_vbox1), label4, FALSE, FALSE, 10);
	gtk_label_set_justify(GTK_LABEL(label4), GTK_JUSTIFY_CENTER);
	gtk_misc_set_padding(GTK_MISC(label4), 8, 4);

	dialog_action_area1 = GTK_DIALOG(dialog_about)->action_area;
	gtk_widget_show(dialog_action_area1);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area1),
	                          GTK_BUTTONBOX_SPREAD);

	okbutton1 = gtk_button_new_from_stock("gtk-ok");
	gtk_widget_show(okbutton1);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_about), okbutton1,
	                             GTK_RESPONSE_OK);
	GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_about, dialog_about, "dialog_about");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_about, dialog_vbox1, "dialog_vbox1");
	GLADE_HOOKUP_OBJECT(dialog_about, label4, "label4");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_about, dialog_action_area1,
	                           "dialog_action_area1");
	GLADE_HOOKUP_OBJECT(dialog_about, okbutton1, "okbutton1");

	return dialog_about;
	}

GtkWidget *
create_dialog_param()
	{
	GtkWidget *dialog_param = NULL;
	GdkPixbuf *dialog_param_icon_pixbuf = NULL;
	GtkWidget *dialog_vbox = NULL;
	GtkWidget *vbox_main = NULL;

	GtkWidget *table_dates = NULL;
	GtkWidget *table_text = NULL;

	GtkWidget *dialog_action_area = NULL;
	GtkWidget *cancelbutton = NULL;
	GtkWidget *okbutton = NULL;
	GtkWidget *scroll = NULL;

	GtkWidget *current = NULL;
	GtkWidget *box = NULL;

	GList *walk = NULL;
	require_parameter *param = NULL;

	int dates_n_col = 2;
	int dates_col = 0, dates_row = 0;
	int text_n_col = 2;
	int text_col = 0, text_row = 0;

	int width = 0, height = 0;

	GtkRequisition req;

//	message("Loading up parameter list!");
//	print_param_list(parameter_list);

	dialog_param = gtk_dialog_new();
	gtk_window_set_type_hint(GTK_WINDOW(dialog_param),
	                         GDK_WINDOW_TYPE_HINT_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog_param), "Parameters");
	gtk_window_set_role(GTK_WINDOW(dialog_param), "papyrus_parameters");
	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog_param), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(dialog_param), GTK_WINDOW(window1));
	gtk_window_set_modal(GTK_WINDOW(dialog_param), TRUE);

	dialog_param_icon_pixbuf = create_pixbuf(PAPYRUS_ICON);
	if (dialog_param_icon_pixbuf)
		{
		gtk_window_set_icon(GTK_WINDOW(dialog_param),
		                    dialog_param_icon_pixbuf);
		gdk_pixbuf_unref(dialog_param_icon_pixbuf);
		}

	dialog_vbox = GTK_DIALOG(dialog_param)->vbox;
	gtk_widget_show(dialog_vbox);

	scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_show(scroll);
	gtk_box_pack_start(GTK_BOX(dialog_vbox), scroll, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(scroll), 16);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
	                               GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(scroll),
	                                    GTK_SHADOW_OUT);

	vbox_main = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox_main);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll),
	                                      vbox_main);

	table_dates = gtk_table_new(10, 2, FALSE);
	gtk_widget_show(table_dates);
	gtk_box_pack_start(GTK_BOX(vbox_main), table_dates, FALSE, FALSE, 0);

	table_text = gtk_table_new(10, 2, FALSE);
	gtk_widget_show(table_text);
	gtk_box_pack_start(GTK_BOX(vbox_main), table_text, FALSE, FALSE, 0);

	/* loop through parameter list to create an appropriate widget for each
	   parameter */

	for (walk = g_list_first(parameter_list); walk; walk = walk->next)
		{
		param = walk->data;

		switch (param->type)
			{
		case TYPE_DATE:
			box = param_widget_date(param->label, param->value, &current);
			param->widget = current;
			gtk_table_attach_defaults(GTK_TABLE(table_dates), box,
			                          dates_col, dates_col + 1, dates_row,
			                          dates_row + 1);
			dates_col = (dates_col + 1) % dates_n_col;
			if (dates_col == 0)
				dates_row++;
			break;

		case TYPE_INT:
			box = param_widget_int(param->label, param->value, &current);
			param->widget = current;
			gtk_table_attach_defaults(GTK_TABLE(table_text), box,
			                          text_col, text_col + 1, text_row,
			                          text_row + 1);
			text_col = (text_col + 1) % text_n_col;
			if (text_col == 0)
				text_row++;
			break;
		case TYPE_COMBO:
			box =
			    param_widget_combo(param->label, param->value, &current,
			                       &param);
			param->widget = current;
			gtk_table_attach_defaults(GTK_TABLE(table_text), box,
			                          text_col, text_col + 1, text_row,
			                          text_row + 1);
			text_col = (text_col + 1) % text_n_col;
			if (text_col == 0)
				text_row++;
			break;
		case TYPE_TEXT:
		default:
			box = param_widget_text(param->label, param->value, &current);
			param->widget = current;
			gtk_table_attach_defaults(GTK_TABLE(table_text), box,
			                          text_col, text_col + 1, text_row,
			                          text_row + 1);
			text_col = (text_col + 1) % text_n_col;
			if (text_col == 0)
				text_row++;
			break;
			}
		}

	dialog_action_area = GTK_DIALOG(dialog_param)->action_area;
	gtk_widget_show(dialog_action_area);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area),
	                          GTK_BUTTONBOX_END);

	cancelbutton = gtk_button_new_from_stock("gtk-cancel");
	gtk_widget_show(cancelbutton);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_param), cancelbutton,
	                             GTK_RESPONSE_CANCEL);
	GTK_WIDGET_SET_FLAGS(cancelbutton, GTK_CAN_DEFAULT);

	okbutton = gtk_button_new_from_stock("gtk-ok");
	gtk_widget_show(okbutton);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_param), okbutton,
	                             GTK_RESPONSE_ACCEPT);
	GTK_WIDGET_SET_FLAGS(okbutton, GTK_CAN_DEFAULT);

	g_signal_connect((gpointer) okbutton, "clicked",
	                 G_CALLBACK(on_param_ok_clicked), NULL);
	g_signal_connect((gpointer) cancelbutton, "clicked",
	                 G_CALLBACK(on_param_cancel_clicked), NULL);
	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_param, dialog_param, "dialog_param");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_param, dialog_vbox, "dialog_vbox");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_param, dialog_action_area,
	                           "dialog_action_area");
	GLADE_HOOKUP_OBJECT(dialog_param, vbox_main, "vbox_main");
	GLADE_HOOKUP_OBJECT(dialog_param, cancelbutton, "cancelbutton");
	GLADE_HOOKUP_OBJECT(dialog_param, okbutton, "okbutton");

	gtk_widget_size_request(vbox_main, &req);
	width = min((&req)->width + 70, 700);
	height = min((&req)->height + 40, 500);
	gtk_widget_set_size_request(scroll, width, height);

	return dialog_param;
	}

GtkWidget *
param_widget_int(gchar * labeltext, gchar * value, GtkWidget ** spin)
	{
	GtkWidget *hbox = NULL;
	GtkWidget *label = NULL;
	GtkAdjustment *adjustment = NULL;
	gdouble val = 0;

	g_assert(labeltext);
	g_assert(spin);

	/* printf("creating int widget (spin) with value %s\n", value); */

	hbox = gtk_hbox_new(FALSE, 10);
	gtk_widget_show(hbox);
	gtk_container_set_border_width(GTK_CONTAINER(hbox), 4);

	label = gtk_label_new(labeltext);
	gtk_widget_show(label);

	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);

	adjustment =
	    GTK_ADJUSTMENT(gtk_adjustment_new
	                   (0, -2147483647, 2147483647, 1.0, 10.0, 10.0));

	*spin = gtk_spin_button_new(adjustment, 1.0, 0);

	if (value)
		{
		val = atof(value);
		if (val)
			gtk_spin_button_set_value(GTK_SPIN_BUTTON(*spin), val);

		}

	gtk_widget_show(*spin);
	gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(*spin), adjustment);
	gtk_box_pack_end(GTK_BOX(hbox), *spin, TRUE, TRUE, 0);
	gtk_spin_button_set_increments(GTK_SPIN_BUTTON(*spin), 1, 10);
	gtk_spin_button_set_snap_to_ticks(GTK_SPIN_BUTTON(*spin), TRUE);
	gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(*spin), TRUE);

	return hbox;
	}

GtkWidget *
param_widget_text(gchar * labeltext, gchar * value, GtkWidget ** entry)
	{

	GtkWidget *hbox = NULL;
	GtkWidget *label = NULL;

	g_assert(labeltext);
	g_assert(entry);

	g_assert(labeltext);
	g_assert(entry);

	/* printf("creating text widget (entry) with value %s\n", value); */

	hbox = gtk_hbox_new(FALSE, 10);
	gtk_widget_show(hbox);
	gtk_container_set_border_width(GTK_CONTAINER(hbox), 4);

	label = gtk_label_new(labeltext);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);

	*entry = gtk_entry_new();
	if (value)
		gtk_entry_set_text(GTK_ENTRY(*entry), value);
	gtk_widget_show(*entry);
	gtk_box_pack_end(GTK_BOX(hbox), *entry, TRUE, TRUE, 0);
	return hbox;
	}

GtkWidget *
param_widget_date(gchar * labeltext, gchar * value, GtkWidget ** calendar)
	{
	GtkWidget *vbox = NULL;
	GtkWidget *label = NULL;

	int day = 0, month = 0, year = 0;

	g_assert(labeltext);
	g_assert(calendar);

	/* printf("creating date widget (calendar) with value %s\n", value); */

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 8);

	label = gtk_label_new(labeltext);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);

	*calendar = gtk_calendar_new();
	if (value)
		{
		if (!date_from_str(value, &year, &month, &day))
			{
			gtk_calendar_select_month(GTK_CALENDAR(*calendar), month - 1,
			                          year);
			gtk_calendar_select_day(GTK_CALENDAR(*calendar), day);
			}
		}
	gtk_widget_show(*calendar);
	gtk_box_pack_start(GTK_BOX(vbox), *calendar, FALSE, FALSE, 0);
	gtk_calendar_display_options(GTK_CALENDAR(*calendar),
	                             GTK_CALENDAR_SHOW_HEADING
	                             | GTK_CALENDAR_SHOW_DAY_NAMES);
	return vbox;
	}

GtkWidget *
param_widget_combo(gchar * labeltext, gchar * value, GtkWidget ** combo,
                   require_parameter ** param)
	{

	GtkWidget *hbox = NULL;
	GtkWidget *label = NULL;
	GList *walk = NULL;
	Database_dd *db = NULL;
	void *conn = NULL;
	void *result = NULL;
	Binding *binding = NULL;
	int found = 0;
	gchar *id_col = NULL, *name_col = NULL;
	gchar *id_val = NULL, *name_val = NULL;
	row_dd *row = NULL;
	int index = 0, i = 0;

	g_assert(labeltext);

	hbox = gtk_hbox_new(FALSE, 10);
	gtk_widget_show(hbox);
	gtk_container_set_border_width(GTK_CONTAINER(hbox), 4);

	label = gtk_label_new(labeltext);
	gtk_widget_show(label);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);

	*combo = gtk_combo_box_new_text();

	/* find database to use by matching name */
	if (databases)
		{
		walk = g_list_first(databases);
		while (walk && !found)
			{
			db = (Database_dd *) walk->data;
			if (!strcmp(db->name, (*param)->database->name))
				{
				mem_free((*param)->database->name);
				mem_free((*param)->database);
				(*param)->database = db;
				mem_verify((*param)->database);

				found = 1;
				}
			walk = walk->next;
			}
		}

	if (found && !(*param)->datalist)
		{
		/* connect to database and get list for combo */
		binding = binding_find((*param)->database->type);
		binding->pap_init();

		conn =
		    binding->pap_connect_db((*param)->database->c_string,
		                            (*param)->database->type);

		if (!conn)
			fprintf(stderr, "Could not connect to database: %s / %s\n",
			        (*param)->database->c_string, (*param)->database->type);
		else
			{
			result = binding->pap_doquery(conn, (*param)->sql);
			id_col = binding->pap_query_column_name(result, 0);
			name_col = binding->pap_query_column_name(result, 1);
			i = 0;
			do
				{
				id_val = binding->pap_query_get_value(result, id_col),
				         name_val =
				             binding->pap_query_get_value(result, name_col);

				row = mem_alloc(sizeof(row_dd));
				row->id = atoi(id_val);
				row->name = mem_strdup(name_val);

				(*param)->datalist =
				    g_list_append((*param)->datalist, row);

				if (value && !strcmp(value, id_val))
					index = i;

				gtk_combo_box_append_text(GTK_COMBO_BOX(*combo), name_val);
				i++;

				}
			while (!binding->pap_query_next(result));

			binding->pap_clearquery(result);
			}

		binding->pap_cleanup();

		if (value)
			gtk_combo_box_set_active(GTK_COMBO_BOX(*combo), index);
		}
	else
		{
		fprintf(stderr, "Could not find database entry: %s\n",
		        (*param)->database->name);
		}

	gtk_widget_show(*combo);
	gtk_box_pack_end(GTK_BOX(hbox), *combo, TRUE, TRUE, 0);
	return hbox;
	}

GtkWidget *
create_dialog_quit(void)
	{
	GtkWidget *dialog_quit = NULL;
	GtkWidget *dialog_vbox4 = NULL;
	GtkWidget *label27 = NULL;
	GtkWidget *dialog_action_area4 = NULL;
	GtkWidget *cancelbutton2 = NULL;
	GtkWidget *okbutton3 = NULL;
	GdkPixbuf *pixbuf;

	dialog_quit = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dialog_quit), _("Papyrus"));
	gtk_window_set_position(GTK_WINDOW(dialog_quit),
	                        GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog_quit), TRUE);
	gtk_window_set_type_hint(GTK_WINDOW(dialog_quit),
	                         GDK_WINDOW_TYPE_HINT_DIALOG);

	pixbuf = create_pixbuf(PAPYRUS_ICON);
	if (pixbuf)
		{
		gtk_window_set_icon(GTK_WINDOW(dialog_quit), pixbuf);
		gdk_pixbuf_unref(pixbuf);
		}

	dialog_vbox4 = GTK_DIALOG(dialog_quit)->vbox;
	gtk_widget_show(dialog_vbox4);

	label27 = gtk_label_new(_("Are you sure you want to quit?"));
	gtk_widget_show(label27);
	gtk_box_pack_start(GTK_BOX(dialog_vbox4), label27, TRUE, TRUE, 0);
	gtk_misc_set_padding(GTK_MISC(label27), 16, 32);

	dialog_action_area4 = GTK_DIALOG(dialog_quit)->action_area;
	gtk_widget_show(dialog_action_area4);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area4),
	                          GTK_BUTTONBOX_END);

	cancelbutton2 = gtk_button_new_from_stock("gtk-cancel");
	gtk_widget_show(cancelbutton2);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_quit), cancelbutton2,
	                             GTK_RESPONSE_CANCEL);
	GTK_WIDGET_SET_FLAGS(cancelbutton2, GTK_CAN_DEFAULT);

	okbutton3 = gtk_button_new_from_stock("gtk-quit");
	gtk_widget_show(okbutton3);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_quit), okbutton3,
	                             GTK_RESPONSE_ACCEPT);
	GTK_WIDGET_SET_FLAGS(okbutton3, GTK_CAN_DEFAULT);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_quit, dialog_quit, "dialog_quit");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_quit, dialog_vbox4, "dialog_vbox4");
	GLADE_HOOKUP_OBJECT(dialog_quit, label27, "label27");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_quit, dialog_action_area4,
	                           "dialog_action_area4");
	GLADE_HOOKUP_OBJECT(dialog_quit, cancelbutton2, "cancelbutton2");
	GLADE_HOOKUP_OBJECT(dialog_quit, okbutton3, "okbutton3");

	return dialog_quit;
	}

void
param_delete_widgets()
	{
	GList *w = NULL;
	require_parameter *p = NULL;

	for (w = g_list_first(parameter_list); w; w = w->next)
		{
		p = w->data;
		gtk_widget_destroy(p->widget);

		//    g_free(p->widget);
		}
	}

GtkWidget *
create_dialog_err(gchar * errMsg)
	{
	GtkWidget *dialog_err = NULL;
	GtkWidget *dialog_vbox1 = NULL;
	GtkWidget *dialog_action_area1 = NULL;
	GtkWidget *okbutton1 = NULL;

	g_assert(errMsg);

	dialog_err = gtk_message_dialog_new(GTK_WINDOW(window1),
	                                    GTK_DIALOG_DESTROY_WITH_PARENT,
	                                    GTK_MESSAGE_ERROR,
	                                    GTK_BUTTONS_NONE, errMsg);
	//  gtk_widget_set_size_request (dialog_err, 340, 155);
	gtk_window_set_title(GTK_WINDOW(dialog_err), _("Papyrus: Error"));
	gtk_window_set_resizable(GTK_WINDOW(dialog_err), FALSE);
	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog_err), TRUE);
	gtk_window_set_type_hint(GTK_WINDOW(dialog_err),
	                         GDK_WINDOW_TYPE_HINT_DIALOG);

	dialog_vbox1 = GTK_DIALOG(dialog_err)->vbox;
	gtk_widget_show(dialog_vbox1);

	dialog_action_area1 = GTK_DIALOG(dialog_err)->action_area;
	gtk_widget_show(dialog_action_area1);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area1),
	                          GTK_BUTTONBOX_SPREAD);

	okbutton1 = gtk_button_new_from_stock("gtk-close");
	gtk_widget_show(okbutton1);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_err), okbutton1,
	                             GTK_RESPONSE_CLOSE);
	GTK_WIDGET_SET_FLAGS(okbutton1, GTK_CAN_DEFAULT);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_err, dialog_err, "dialog_err");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_err, dialog_vbox1, "dialog_vbox1");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_err, dialog_action_area1,
	                           "dialog_action_area1");
	GLADE_HOOKUP_OBJECT(dialog_err, okbutton1, "okbutton1");

	return dialog_err;
	}

/* if name and path are both non-null, this dialog is editing the entry
   otherwise this is a new entry 
*/
GtkWidget *
create_dialog_savefav(gchar * name, gchar * path)
	{
	GtkWidget *dialog_savefav;
	GtkWidget *dialog_vbox5;
	GtkWidget *table1;
	GtkWidget *entry_sfname;
	GtkWidget *entry_sfpath;
	GtkWidget *label_name;
	GtkWidget *label_path;
	GtkWidget *dialog_action_area5;
	GtkWidget *button_sfsave;
	GtkWidget *button_sfcancel;
	GdkPixbuf *pixbuf;

	dialog_savefav = gtk_dialog_new();
	gtk_widget_set_name(dialog_savefav, "dialog_savefav");
	gtk_window_set_title(GTK_WINDOW(dialog_savefav), _("Save Favourite"));
	gtk_window_set_position(GTK_WINDOW(dialog_savefav),
	                        GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_modal(GTK_WINDOW(dialog_savefav), TRUE);
	gtk_window_set_resizable(GTK_WINDOW(dialog_savefav), FALSE);
	gtk_window_set_type_hint(GTK_WINDOW(dialog_savefav),
	                         GDK_WINDOW_TYPE_HINT_DIALOG);
	gtk_window_set_modal(GTK_WINDOW(dialog_savefav), TRUE);
	gtk_window_set_skip_taskbar_hint(GTK_WINDOW(dialog_savefav), TRUE);

	pixbuf = create_pixbuf(PAPYRUS_ICON);
	if (pixbuf)
		{
		gtk_window_set_icon(GTK_WINDOW(dialog_savefav), pixbuf);
		gdk_pixbuf_unref(pixbuf);
		}

	dialog_vbox5 = GTK_DIALOG(dialog_savefav)->vbox;
	gtk_widget_set_name(dialog_vbox5, "dialog_vbox5");
	gtk_widget_show(dialog_vbox5);

	table1 = gtk_table_new(2, 2, FALSE);
	gtk_widget_set_name(table1, "table1");
	gtk_widget_show(table1);
	gtk_box_pack_start(GTK_BOX(dialog_vbox5), table1, FALSE, TRUE, 8);

	entry_sfname = gtk_entry_new();
	gtk_widget_set_name(entry_sfname, "entry_sfname");
	gtk_widget_show(entry_sfname);
	gtk_table_attach(GTK_TABLE(table1), entry_sfname, 1, 2, 0, 1,
	                 (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
	                 (GtkAttachOptions) (0), 8, 8);
	if (name)
		gtk_entry_set_text(GTK_ENTRY(entry_sfname), name);

	entry_sfpath = gtk_entry_new();
	gtk_widget_set_name(entry_sfpath, "entry_sfpath");
	gtk_widget_show(entry_sfpath);
	gtk_table_attach(GTK_TABLE(table1), entry_sfpath, 1, 2, 1, 2,
	                 (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
	                 (GtkAttachOptions) (0), 8, 8);
	if (path)
		gtk_entry_set_text(GTK_ENTRY(entry_sfpath), path);

	label_name = gtk_label_new(_("Name"));
	gtk_widget_set_name(label_name, "label_name");
	gtk_widget_show(label_name);
	gtk_table_attach(GTK_TABLE(table1), label_name, 0, 1, 0, 1,
	                 (GtkAttachOptions) (GTK_FILL),
	                 (GtkAttachOptions) (0), 8, 0);

	label_path = gtk_label_new(_("Path"));
	gtk_widget_set_name(label_path, "label_path");
	gtk_widget_show(label_path);
	gtk_table_attach(GTK_TABLE(table1), label_path, 0, 1, 1, 2,
	                 (GtkAttachOptions) (GTK_FILL),
	                 (GtkAttachOptions) (0), 8, 0);

	dialog_action_area5 = GTK_DIALOG(dialog_savefav)->action_area;
	gtk_widget_set_name(dialog_action_area5, "dialog_action_area5");
	gtk_widget_show(dialog_action_area5);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(dialog_action_area5),
	                          GTK_BUTTONBOX_END);

	button_sfsave = gtk_button_new_from_stock("gtk-save");
	gtk_widget_set_name(button_sfsave, "button_sfsave");
	gtk_widget_show(button_sfsave);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_savefav), button_sfsave,
	                             GTK_RESPONSE_ACCEPT);
	GTK_WIDGET_SET_FLAGS(button_sfsave, GTK_CAN_DEFAULT);

	if (!name || !path)
		gtk_widget_set_sensitive(button_sfsave, FALSE);

	button_sfcancel = gtk_button_new_from_stock("gtk-cancel");
	gtk_widget_set_name(button_sfcancel, "button_sfcancel");
	gtk_widget_show(button_sfcancel);
	gtk_dialog_add_action_widget(GTK_DIALOG(dialog_savefav), button_sfcancel,
	                             GTK_RESPONSE_CANCEL);

	g_signal_connect((gpointer) entry_sfname, "changed",
	                 G_CALLBACK(on_entry_sf_changed), NULL);
	g_signal_connect((gpointer) entry_sfpath, "changed",
	                 G_CALLBACK(on_entry_sf_changed), NULL);

	/* Store pointers to all widgets, for use by lookup_widget(). */
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_savefav, dialog_savefav, "dialog_savefav");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_savefav, dialog_vbox5, "dialog_vbox5");
	GLADE_HOOKUP_OBJECT(dialog_savefav, table1, "table1");
	GLADE_HOOKUP_OBJECT(window1, entry_sfname, "entry_sfname");
	GLADE_HOOKUP_OBJECT(window1, entry_sfpath, "entry_sfpath");
	GLADE_HOOKUP_OBJECT(dialog_savefav, label_name, "label_name");
	GLADE_HOOKUP_OBJECT(dialog_savefav, label_path, "label_path");
	GLADE_HOOKUP_OBJECT_NO_REF(dialog_savefav, dialog_action_area5,
	                           "dialog_action_area5");
	GLADE_HOOKUP_OBJECT(dialog_savefav, button_sfsave, "button_sfsave");
	GLADE_HOOKUP_OBJECT(dialog_savefav, button_sfcancel, "button_sfcancel");

	gtk_widget_grab_default(button_sfsave);

	return dialog_savefav;
	}
