#ifndef __report_h
#define __report_h

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#define TYPE_TEXT 		1
#define TYPE_INT 		2
#define TYPE_DATE		3
#define	TYPE_COMBO		4

typedef struct
{
	gchar *name;
	gchar *type;
	gchar *c_string;
}
Database_dd;

typedef struct
{
	gchar *name;
	int id;
}
row_dd;

typedef struct
{
	int type;
	/* unique name (comes from <requires>here</requires> */
	gchar *ident;

	/* label to appear in GUI comes from <requires name="here"> */
	gchar *label;

	gchar *value;

	/* for dropdown */
	gchar *sql;
	GList *datalist;
	Database_dd *database;
	
	GtkWidget *widget;
}
require_parameter;

gboolean run_report();
gchar * execute_ok(GtkWidget *start);
gchar * param_ok(GtkWidget *start);
xmlDoc * parse_xml_doc(gchar * xmlfilename);
void param_addtolist(xmlNode * a_node, GList **list);
void free_databases();
void free_parameter_list();
void free_require_parameter(require_parameter *p);

void param_getfromdoc(xmlDoc *doc, GList **param_list);
gchar * change_extension(gchar *oldfilename, gchar *ext);
void param_list_merge(GList **list_cur, GList **list_new);
int param_type_from_str(gchar *str);
int param_store_list();
void report_savefav();
int date_from_str(char *str, int *year, int *month, int *day);
void report_write_favourites(GtkTreeModel *model);
#endif
