#include <stdio.h>
#include <stdlib.h>

#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#include "debug.h"
#include "xml2html.h"

int main (int argc, char *argv[])
{
   xmlDoc *doc;

	debug_init ();

	if (argc != 2)
		{
		errormsg ("Usage: %s inputfile", argv[0]);
		return EXIT_FAILURE;
		}

	doc = xmlParseFile (argv[1]);
 
   if (!doc)
		{
		errormsg ("Error parsing input");
		return EXIT_FAILURE;
		}

	xml_doc_to_html (doc, stdout);

	debug_cleanup ();

   return EXIT_SUCCESS;
}
