#ifndef LATEX_OUTPUT_H
#define LATEX_OUTPUT_H

char *convert_width (char *width);

int latex_image (FILE *output, xmlNode *image, int border);

int latex_string (FILE *output, char *text);
int latex_title(FILE * output, xmlNode * title);
int latex_label (FILE *output, xmlNode *label, int border, int paragraph);

int latex_horizontal_spacer (FILE *output, char *width);

int latex_cell_multicol (FILE *output, xmlNode *cell, int span, int border);
int latex_cell_multicol_end (FILE *output);

int latex_line (FILE *output);

int latex_column_sep (FILE *output);
int latex_row_end (FILE *output);

int latex_table_topline (FILE *output);
int latex_table_bottomline (FILE *output);
int latex_table_sep (FILE *output);

int latex_table_header_start (FILE *output);
int latex_table_header_end (FILE *output);
int latex_table_footer_start (FILE *output, int border);
int latex_table_footer_end (FILE *output, int border);

int latex_table_width (FILE *output, xmlNode *table);
int latex_table_start (FILE *output, xmlNode *table, int nested, char align);
int latex_table_end (FILE *output, int nested);

int latex_header (FILE *output, xmlNode *report);
int latex_footer (FILE *output);

#endif /* LATEX_OUTPUT_H */
